     DECLARE SUB METER.I.O (expect.response%)
     DIM SHARED METER.CMD$, METER.RESP$, METER.ERROR%
     DIM CHAN$(3), PROBE$(3), MODE$(3), RANGE$(3), FILTER$(3)
     DIM HOLD$(3), CLASS$(3), LOCLASS$(3), HICLASS$(3), REL$(3)
     DIM G.T$(3), GAUSS$(8), TESLA$(8)

     GAUSS$(1) = "3 G":     TESLA$(1) = "300 uT"
     GAUSS$(2) = "30 G":    TESLA$(2) = "3 mT"
     GAUSS$(3) = "300 G":   TESLA$(3) = "30 mT"
     GAUSS$(4) = "3 KG":    TESLA$(4) = "300 mT"
     GAUSS$(5) = "30 KG":   TESLA$(5) = "3 T"
     GAUSS$(6) = "300 KG":  TESLA$(6) = "30 T"
     GAUSS$(7) = "3 MG":    TESLA$(7) = "300 T"

     CLS
     PRINT "*********************************************************************"
     PRINT "                RS-232 DEMONSTRATION PROGRAM FOR"
     PRINT "           F.W.BELL 9950 / 9550 GAUSS / TESLA METERS"
     PRINT "*********************************************************************"
     PRINT "This program demonstrates the use of the RS-232 serial port on an"
     PRINT " F.W.BELL 9950 or 9550 gauss / tesla meter.  This Q-BASIC program"
     PRINT " was intended for use on any 80x86 PC using the COM-1 serial port."
     PRINT " This program can be used to verify the connection between the"
     PRINT " meter and computer as well as provide a template for system"
     PRINT " programmers who wish to create their own programs."
     PRINT
     PRINT "It is important to use the proper interface cable.  A straight-"
     PRINT " through cable will not work.  See Section-VI of the user's manual"
     PRINT " for suggestions.  The cable without handshaking is recommended."
     PRINT
     PRINT "The meter's RS-232 communications parameters should be set using"
     PRINT " the COMMUNICATIONS FORMAT menu to"
     PRINT
     PRINT "         9600 baud, 1 stop bit, 7 data bits and odd parity."
     PRINT
     PRINT "When executed this program will obtain and display the present"
     PRINT " setup of the instrument, and then will acquire flux readings on"
     PRINT " a continuous basis."
     PRINT
     PRINT "Place the meter in the RUN mode and press any key to continue...";

     DO
     LOOP UNTIL INKEY$ <> "":  CLS

     PRINT "Initializing COM1 port..."
     OPEN "COM2:9600,O,7,1,CS,DS,CD" FOR RANDOM AS #1

     '=========================================
     'Request meter and probe I.D. information.
     '=========================================
RESTART:
     CLS
     PRINT "Retrieving meter I.D. information...": PRINT
     METER.CMD$ = "*IDN?;*OPT?": CALL METER.I.O(1)

     IF METER.ERROR% = 1 THEN
         PRINT "Meter did not respond as requested.  Please check your"
         PRINT " interface cable.  Make sure it is connected to the COM1"
         PRINT " port on your computer.  Verify that the meter is set for"
         PRINT " the proper baud rate, character length, etc.  Make sure"
         PRINT " the meter is in the RUN mode."
         END
     END IF

     '===============================
     'Display meter I.D. information.
     '===============================
     POS2% = INSTR(METER.RESP$, ";")
     PRINT "Meter I.D. = "; LEFT$(METER.RESP$, POS2% - 1)
     MODEL% = 9950
     IF INSTR(METER.RESP$, "9550") <> 0 THEN MODEL% = 9550

     '==========================================
     'Save the status of each channel and probe.
     '==========================================

     FOR X% = 0 TO 2
         POS1% = INSTR(POS2% + 1, METER.RESP$, ",")
         CHAN$(X%) = MID$(METER.RESP$, POS1% - 1, 1)
         POS2% = INSTR(POS1% + 1, METER.RESP$, ",")
         IF POS2% = 0 THEN POS2% = INSTR(POS1% + 1, METER.RESP$, ";")
         PROBE$(X%) = MID$(METER.RESP$, POS1% + 1, (POS2% - POS1% - 1))
         IF MODEL% = 9550 THEN EXIT FOR
     NEXT X%

     '====================================================
     'Obtain and display the present setup of each channel
     ' in a table format.
     '====================================================
     LOCATE 10, 1: PRINT "PROBE";
     LOCATE 11, 1: PRINT "MODE";
     LOCATE 12, 1: PRINT "RANGE";
     LOCATE 13, 1: PRINT "FILTER";
     LOCATE 14, 1: PRINT "PEAK HOLD";
     LOCATE 15, 1: PRINT "CLASSIFIER";
     LOCATE 16, 1: PRINT "LO CLASS LIMIT";
     LOCATE 17, 1: PRINT "HI CLASS LIMIT";
     LOCATE 18, 1: PRINT "RELATIVE VALUE";
     LOCATE 19, 1: PRINT "PRESENT READING";
     LOCATE 23, 1
     PRINT "Flux readings will be updated until any key is pressed."

     FOR X% = 0 TO 2
         CH$ = RIGHT$(STR$(X% + 1), 1)
         SCREEN.COL = 20 * (X% + 1)

         '=====================================================
         'If this is a 9950 then display the status of the next
         ' channel and probe.  If this is a 9550, display the
         ' status of the probe only.
         '=====================================================

         IF MODEL% = 9950 THEN
             LOCATE 7, SCREEN.COL: PRINT "   CHANNEL-" + CH$;
             LOCATE 8, SCREEN.COL: PRINT "---------------"
             IF CHAN$(X%) = "0" THEN
                 LOCATE 9, SCREEN.COL: PRINT " NOT INSTALLED"
             END IF
         ELSE
             LOCATE 7, SCREEN.COL: PRINT "    STATUS"
             LOCATE 8, SCREEN.COL: PRINT "---------------"
         END IF

         IF CHAN$(X%) = "0" THEN
             GOTO CONT.TABLE
         ELSE
             LOCATE 10, SCREEN.COL
             IF PROBE$(X%) = "0" THEN
                 PRINT "NOT INSTALLED"
             ELSE
                 PRINT PROBE$(X%)
             END IF
         END IF

         '====================================
         'Obtain and display the present mode.
         '====================================
         METER.CMD$ = ":UNIT:FLUX" + CH$ + "?": CALL METER.I.O(1)
         POS1% = INSTR(METER.RESP$, ";")
         MODE$(X%) = LEFT$(METER.RESP$, POS1% - 1)
         LOCATE 11, SCREEN.COL: PRINT MODE$(X%)
         IF INSTR(MODE$(X%), "GAUSS") <> 0 THEN
             G.T$(X%) = " G"
         ELSE
             G.T$(X%) = " T"
         END IF

         '=====================================
         'Obtain and display the present range.
         '=====================================
         METER.CMD$ = ":SENSE" + CH$ + ":FLUX:RANGE?": CALL METER.I.O(1)
         RANGE$(X%) = LEFT$(METER.RESP$, 1)
         POS1% = VAL(RANGE$(X%))
         LOCATE 12, SCREEN.COL
         IF G.T$(X%) = " G" THEN
             PRINT GAUSS$(POS1%)
         ELSE
             PRINT TESLA$(POS1%)
         END IF

         '===================================================
         'Obtain and display the present state of the filter.
         '===================================================
         METER.CMD$ = ":SENSE" + CH$ + ":FLUX:AVER:STAT?": CALL METER.I.O(1)
         POS1% = INSTR(METER.RESP$, ";")
         FILTER$(X%) = LEFT$(METER.RESP$, POS1% - 1)
         LOCATE 13, SCREEN.COL
         IF FILTER$(X%) = "0" THEN
             PRINT "OFF"
         ELSE
             PRINT "ON"
         END IF
            
         '===============================================================
         'Obtain and display the present state of the peak hold function.
         '===============================================================
         METER.CMD$ = ":SENSE" + CH$ + ":HOLD:STAT?": CALL METER.I.O(1)
         POS1% = INSTR(METER.RESP$, ";")
         HOLD$(X%) = LEFT$(METER.RESP$, POS1% - 1)
         LOCATE 14, SCREEN.COL
         IF HOLD$(X%) = "0" THEN
             PRINT "OFF"
         ELSE
             PRINT "ON"
         END IF
             
         '================================================================
         'Obtain and display the present state of the classifier function.
         '================================================================
         METER.CMD$ = ":CALC" + CH$ + ":LIM:STAT?": CALL METER.I.O(1)
         POS1% = INSTR(METER.RESP$, ";")
         CLASS$(X%) = LEFT$(METER.RESP$, POS1% - 1)
         LOCATE 15, SCREEN.COL
         IF CLASS$(X%) = "0" THEN
             PRINT "OFF"
         ELSE
             PRINT "ON"
         END IF

         METER.CMD$ = ":CALC" + CH$ + ":LIM:LOW?": CALL METER.I.O(1)
         POS1% = INSTR(METER.RESP$, ";")
         LOCLASS$(X%) = LEFT$(METER.RESP$, POS1% - 1)
         LOCATE 16, SCREEN.COL
         PRINT LOCLASS$(X%); G.T$(X%)
         
         METER.CMD$ = ":CALC" + CH$ + ":LIM:UPP?": CALL METER.I.O(1)
         POS1% = INSTR(METER.RESP$, ";")
         HICLASS$(X%) = LEFT$(METER.RESP$, POS1% - 1)
         LOCATE 17, SCREEN.COL
         PRINT HICLASS$(X%); G.T$(X%)

         '==============================================================
         'Obtain and display the present state of the relative function.
         '==============================================================
         METER.CMD$ = ":SYST:AREL" + CH$ + ":STAT?": CALL METER.I.O(1)
         POS1% = INSTR(METER.RESP$, ";")
         REL$(X%) = LEFT$(METER.RESP$, POS1% - 1)
         LOCATE 18, SCREEN.COL
         IF REL$(X%) = "0" THEN
             PRINT "OFF"
         ELSE
             METER.CMD$ = ":SYST:AREL" + CH$ + ":VAL?": CALL METER.I.O(1)
             POS1% = INSTR(METER.RESP$, ";")
             REL$(X%) = LEFT$(METER.RESP$, POS1% - 1)
             LOCATE 18, SCREEN.COL
             PRINT REL$(X%); G.T$(X%)
         END IF

CONT.TABLE:
         IF MODEL% = 9550 THEN EXIT FOR
     NEXT X%
    
     '===========================================================
     'Clear error and status registers, lockout front panel.
     ' Obtain and display the flux readings on a continuous basis
     ' until user presses a key.
     '===========================================================
     METER.CMD$ = "*REN;:SYST:CLEAR;:STATUS:PRESET;*OPC?": CALL METER.I.O(1)

     DO
         METER.CMD$ = ":STAT:MEAS:EVENT?": CALL METER.I.O(1)
         X% = VAL(METER.RESP$)

         '================================================================
         'If Channel-1 is ready with a new reading, obtain and display it.
         '================================================================
         IF (X% AND 8) <> 0 THEN
             IF PROBE$(0) = "0" THEN GOTO RESTART
             METER.CMD$ = ":MEAS:FLUX1?": CALL METER.I.O(1)
             IF INSTR(METER.RESP$, "ERR") <> 0 THEN
                 GOTO RESTART
             ELSE
                 POS1% = INSTR(METER.RESP$, ",")
                 LOCATE 19, 20: PRINT LEFT$(METER.RESP$, POS1% - 1);
             END IF
         END IF

         '================================================================
         'If Channel-2 is ready with a new reading, obtain and display it.
         '================================================================
         IF (X% AND 16) <> 0 THEN
             IF PROBE$(1) = "0" THEN GOTO RESTART
             METER.CMD$ = ":MEAS:FLUX2?": CALL METER.I.O(1)
             IF INSTR(METER.RESP$, "ERR") <> 0 THEN
                 GOTO RESTART
             ELSE
                 POS1% = INSTR(METER.RESP$, ",")
                 LOCATE 19, 40: PRINT LEFT$(METER.RESP$, POS1% - 1);
             END IF
         END IF

         '================================================================
         'If Channel-3 is ready with a new reading, obtain and display it.
         '================================================================
         IF (X% AND 32) <> 0 THEN
             IF PROBE$(2) = "0" THEN GOTO RESTART
             METER.CMD$ = ":MEAS:FLUX3?": CALL METER.I.O(1)
             IF INSTR(METER.RESP$, "ERR") <> 0 THEN
                 GOTO RESTART
             ELSE
                 POS1% = INSTR(METER.RESP$, ",")
                 LOCATE 19, 60: PRINT LEFT$(METER.RESP$, POS1% - 1);
             END IF
         END IF

     LOOP UNTIL INKEY$ <> ""
     METER.CMD$ = "*GTL": CALL METER.I.O(0)

     END

SUB METER.I.O (expect.response%)
     '========================================================================
     '                     METER INPUT / OUTPUT SUBROUTINE
     '========================================================================
     ' This subroutine transmits the contents of the global buffer
     ' <METER.CMD$> to the meter, followed by the line feed terminator.
     '
     ' If the variable <expect.response%> is non-zero, the subroutine will
     ' wait for a response from the meter and store it in the global buffer
     ' <METER.RESP$>.  If no response occurs within 5 seconds the global
     ' variable <METER.ERROR%> will be set to 1.
     '========================================================================
     METER.ERROR% = 0                        'Clear error flag.
     DO UNTIL EOF(1) = -1
         METER.RESP$ = INPUT$(LOC(1), #1)    'Remove any garbage from
     LOOP                                    ' input buffer.

     PRINT #1, METER.CMD$ + CHR$(10);        'Send command string followed
                                             ' by a line feed.

     IF expect.response% = 0 THEN EXIT SUB   'Done if no response expected.
     METER.RESP$ = ""                        'Null response buffer.

     'Get present time, but if it is approaching the rollover point,
     ' wait for it to rollover and then continue.

RESET.TIMER:
     START.TIME = TIMER
     IF START.TIME > 86394! THEN GOTO RESET.TIMER

    'Store as many characters as are in the input buffer.  If
    ' one of them is the line feed character, return to caller.
    ' If no response is received within 5 seconds, report an error.

LOOK.FOR.INPUT:
     IF EOF(1) = -1 THEN
         IF (TIMER - START.TIME) > 5 THEN
             METER.ERROR% = 1
             EXIT SUB
         ELSE
             GOTO LOOK.FOR.INPUT
         END IF

     ELSE
         METER.RESP$ = METER.RESP$ + INPUT$(LOC(1), #1)
         IF (INSTR(METER.RESP$, CHR$(10))) = 0 THEN GOTO RESET.TIMER
         EXIT SUB
     END IF

     END SUB

